package de.mpg.mpimet.yacgui.xml;

/**
 * Copyright (c) 2013 Max-Planck-Institute for Meteorology, Hamburg.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *   - Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *
 *   - Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 *   - Neither the name of Oracle or the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 * IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/**
 * String constants for &lt;coupling&gt; and &lt;component&gt; xml Java 
 * representations.<br>
 *
 * Element names and attribtue names according to coupling.xsd and 
 * component.xsd.
 */

public class Dom {
	
	public static final String COUPLING = "coupling";
	public static final String REDIRECT = "redirect";
	public static final String COMPONENTS = "components";
	public static final String TRANSIENTS = "transients";
	public static final String TRANSIENT_GRID_REFS = "transient_grid_refs";
	public static final String GRIDS = "grids";
	public static final String DATES = "dates";
	public static final String START_DATE = "start_date";
	public static final String END_DATE = "end_date";
	public static final String CALENDAR = "calendar";
	public static final String TIMESTEP_UNIT = "timestep_unit";
	public static final String COUPLES = "couples";
	public static final String COMPONENT = "component";
	public static final String ID = "id";
	public static final String NAME = "name";
	public static final String MODEL = "model";
	public static final String SIMULATED = "simulated";
	public static final String TIMESTEP = "timestep";
	public static final String TRANSIENT = "transient";
	public static final String MAPPING_ON_SOURCE = "mapping_on_source";
	public static final String TRANSIENT_GRID_REF = "transient_grid_ref";
	public static final String GRID = "grid";
	public static final String COUPLE = "couple";
	public static final String COMPONENT1 = "component1";
	public static final String COMPONENT2 = "component2";
	public static final String TRANSIENT_COUPLE = "transient_couple";
	public static final String SOURCE = "source";
	public static final String TARGET = "target";
	public static final String COUPLING_PERIOD = "coupling_period";
	public static final String SOURCE_TIMELAG = "source_timelag";
	public static final String TARGET_TIMELAG = "target_timelag";
	public static final String INTERPOLATION_REQUIREMENTS = "interpolation_requirements";
	public static final String INTERPOLATION = "interpolation";
	public static final String MASK_VALUE = "mask_value";
	public static final String ENFORCE_WRITE_WEIGHT_FILE = "enforce_write_weight_file";
	
	public static final String CREATED = "created";
	
	public class Attribute {
		public static final String XMLNS = "xmlns";
		public static final String XMLNS_XSI = "xmlns:xsi";
		public static final String XSI_SCHEMALOCATION = "xsi:schemaLocation";
		
		public static final String REDIRECT_STDOUT = "redirect_stdout";
		public static final String REDIRECT_OF_ROOT = "redirect_of_root";
		public static final String ID = "id";
		public static final String TRANSIENT_REF = "transient_ref";
		public static final String GRID_REF = "grid_ref";
		public static final String COLLECTION_SIZE = "collection_size";
		public static final String TRANSIENT_STANDARD_NAME = "transient_standard_name";
		public static final String ALIAS_NAME = "alias_name";
		public static final String COMPONENT_ID = "component_id";
		public static final String TRANSIENT_ID = "transient_id";
		public static final String COMPONENT_REF = "component_ref";
		public static final String TRANSIENT_GRID_REF = "transient_grid_ref";
		public static final String OPERATION = "operation";
		public static final String METHOD = "method";
		
		public static final String N = "n";
		public static final String WEIGHTED = "weighted";
		public static final String RBF_KERNEL = "rbf_kernel";
		public static final String RBF_SCALE = "rbf_scale";
		public static final String GAUSS_SCALE = "gauss_scale";
		
		public static final String CONSERVATIVE_ORDER = "order";
		public static final String ENFORCED_CONSERVATION = "enforced_conservation";
		public static final String PARTIAL_COVERAGE = "partial_coverage";
		public static final String NORMALISATION = "normalisation";
		
		public static final String SPREAD_DISTANCE = "spread_distance";

		public static final String CREEP_DISTANCE = "creep_distance";

		public static final String EXTEND_SOURCE_PATCH = "extend_source_patch";
		public static final String ALLOW_CORNER_WEIGHT = "allow_corner_weight";
		
		public static final String USER_VALUE = "user_value";		

		public static final String AT_SOURCE_BEFORE_INTERPOLATION = "at_source_before_interpolation";
		public static final String AT_SOURCE_AFTER_INTERPOLATION = "at_source_after_interpolation";
		public static final String AT_TARGET = "at_target";
		
		public static final String FILENAME = "filename";
		
		public static final String DATE = "date";
		public static final String TOOL = "tool";
	}
	
	public class Value {
		public static final String XMLNS = "http://www.w3schools.com"; 
		public static final String XMLNS_XSI = "http://www.w3.org/2001/XMLSchema-instance";
		public static final String XSI_SCHEMALOCATION = "http://www.w3schools.com coupling.xsd";
		public static final String NONE = "none";
		
		public static final String FRACAREA = "FRACAREA";
		public static final String DESTAREA = "DESTAREA";
		
		public static final String CELL = "CELL";
		public static final String EDGE = "EDGE";
		public static final String CORNER = "CORNER";
		
		public static final String GAUSS_KERNEL = "GAUSS_KERNEL";
		public static final String DISTANCE_WEIGHTED = "DISTANCE_WEIGHTED";
                public static final String BARYCENTRIC_COORDINATE = "BARYCENTRIC_COORDINATE";
		public static final String GAUSS_WEIGHTED = "GAUSS_WEIGHTED";
		public static final String ARITHMETIC_AVERAGE = "ARITHMETIC_AVERAGE";
	}
}
